/************************************************************************
	Example specification file for the 68000 family.  This example
	assumes ROM is at address 0x0000 and RAM is at address 0xC000.
	Region "data" (which contains initialized RAM variables) must
	be linked into RAM to give the variables their correct addresses,
	but will be downloaded into ROM at location DATA using downloader
	option "-m data,DATA".  Startup code will copy it from location
	DATA back into RAM.

************************************************************************/

partition { overlay {
    region {} vectors[size=0x400];	/* This is where exception vecs live */
    region {} data[roundsize=4];	/* RAM to be initialized on reset */
    region {} ram[roundsize=4];		/* RAM to be zeroed on reset */
	MALLOC_SIZE = 0x1f000 - $;		/* This is what is left over	*/
     MALLOC_START = $;
    region {} malloc;	/* RAM available to malloc() */
	region {} stack[addr = 0x1f000,size=0x1000];	/* stack of at least 0x1000 bytes */
    STKTOP = $;				/* stack pointer reset value */
} o2; } RAM[addr=0x0000];

partition { overlay {
    region {} vects;		/* reset vector  and exception vectors */
    region {} code;			/* executable code */
    region {} const;			/* constant data */
    region {} string;			/* constant strings */
    DATA = $;				/* where to download region data */
} o1; } ROM[addr=0xFFFF0000];

