/*
** defines for MIDI port
*/

#define UART	0xfffc0000
#define MODE_REG_B	8
#define STATUS_REG_B	9
#define COMMAND_REG_B	10
#define AUX_CONTROL_REG	4
#define INPUT_PORT_CHANGE_REG	4
#define INTERRUPT_STATUS_REG	5
#define INTERRUPT_MASK_REG	5
#define COUNTER_UPPER_REG	6
#define COUNTER_LOWER_REG	7
#define INTERRUPT_VECTOR_REG	12
#define INPUT_PORT_REG	13
#define OUTPUT_PORT_CONFIG	13
#define START_COUNTER	14
#define BIT_SET_COMMAND	14
#define STOP_COUNTER	15
#define BIT_RESET_COMMAND	15
#define OUTPUT_PORT	14


/*
** defines for port a UART
*/
#define TX_B_RDY_IRQ	0x10	/*	transmit ready interrupt mask	*/
#define RX_B_RDY_IRQ	0x20	/*	reciever ready interrupt mask	*/
#define DELTA_BREAK_B	0x40	/*	delta break a iqr mask	*/

#ifndef __IOREC__

#define TX_EMPTY 0x08

typedef struct {
	char *buffer;
	int head;	/*	head index in buffer	*/
	int tail;	/*	tail index in buffer	*/
	int size;	/*	size of buffer	*/
	int nchars;	/*	unused flag	*/
	int high;		/*	high water mark	*/
	int low;		/*	low water mark	*/
}IO_REC;
#define __IOREC__
#endif

/*
** Parameters to tell what kind of STATUS
*/

#define RECEIVE_STAT	1		/*	get number of characters in recieve buff	*/
#define SEND_STAT		2		/*	get number of characters in transmit buff	*/

/*
** function codes for XIO call
*/

#define SET_BAUD_RATE	0x20
#define SEND_BREAK	0x21
#define WAIT_EMPTY	0x22
#define SET_MODE	0x23
#define SET_INPUT_BUFFER	0x24
#define SET_OUTPUT_BUFFER	0x25

